#!/bin/sh
# Creamos una tabla temporal
echo "CREATE TABLE temp1 (LIKE calles_nombres);
INSERT INTO temp1 SELECT * FROM calles_nombres WHERE id_ciudad = 324
 OR id_ciudad = 1381
 OR id_ciudad = 2559
 OR id_ciudad = 499
 OR id_ciudad = 2467
 OR id_ciudad = 3649
 OR id_ciudad = 4465
 OR id_ciudad = 3772
 OR id_ciudad = 3376
 OR id_ciudad = 4566
 OR id_ciudad = 3587
 OR id_ciudad = 4809
 OR id_ciudad = 4667
 OR id_ciudad = 1880
 OR id_ciudad = 4197
 OR id_ciudad = 751
 OR id_ciudad = 3648
 OR id_ciudad = 3270
 OR id_ciudad = 3657
 OR id_ciudad = 4142
 OR id_ciudad = 3396
 OR id_ciudad = 2832
 OR id_ciudad = 689
 OR id_ciudad = 1272
 OR id_ciudad = 1868
 OR id_ciudad = 2584
 OR id_ciudad = 2518
 OR id_ciudad = 2662
 OR id_ciudad = 4426
 OR id_ciudad = 4746
 OR id_ciudad = 1965
 OR id_ciudad = 1671
 OR id_ciudad = 3932
 OR id_ciudad = 3648
 OR id_ciudad = 3064
 OR id_ciudad = 1600 
 OR id_ciudad = 4804
 OR id_ciudad = 4269
 OR id_ciudad = 2326
 OR id_ciudad = 4872
" > cn_tmp.sql
psql -d gis2 -f cn_tmp.sql

# Volcamos los datos de la tabla temporal
pg_dump --column-inserts -t temp1 gis2 > temp1.sql
# Cambiamos el nombre de la tabla en el archivo
sed 's/temp1/calles_nombres/g' temp1.sql > calles_nombres.sql
# Borramos archivo temporal
rm temp1.sql

# Borramos la tabla temporal
echo "DROP TABLE IF EXISTS temp1;" > cn_tmp.sql
psql -d gis2 -f cn_tmp.sql

# Borramos la tabla de irt
echo "DROP TABLE IF EXISTS calles_nombres;" > cn_tmp.sql
psql -d irt -f cn_tmp.sql

# Cargamos el sql resultante
psql -d irt -f calles_nombres.sql
rm calles_nombres.sql

# Definimos la primary key
echo "ALTER TABLE calles_nombres ADD PRIMARY KEY ("id");
GRANT SELECT on calles_nombres to soluciones;" > cn_tmp.sql
psql -d irt -f cn_tmp.sql
rm cn_tmp.sql
