# -*- coding: utf-8 -*-

from at.utiles.validaciones_generales import ValidacionesGenerales


class ValidacionesEspecificas(ValidacionesGenerales):
    '''
        Esta clase contiene m�todos para validar cualquier tipo de parametro
        que quiera ingresar un usuario.
    '''

    def validar_id_calle(self, valor):
        '''
            Valido un ID del tipo entero, positivo, el dato es obligatorio
            y menor que 99999999999.
        '''

        self.validar_no_vacio(valor)

        self.validar_entero(valor)

        self.validar_positivo(valor)

        maximo = 99999999999
        self.validar_numero_maximo(maximo, valor)

        return True

    def validar_id_ciudad(self, valor):
        '''
            Valido un ID del tipo entero, positivo, el dato es obligatorio
            y menor que 99999999999.
        '''

        self.validar_no_vacio(valor)

        self.validar_entero(valor)

        self.validar_positivo(valor)

        maximo = 99999999999
        self.validar_numero_maximo(maximo, valor)

        return True

    def validar_id_mapa(self, valor):
        '''
            Valido un ID del tipo entero, positivo, el dato es obligatorio
            y menor que 99999999999.
        '''

        self.validar_no_vacio(valor)

        self.validar_entero(valor)

        self.validar_positivo(valor)

        maximo = 99999999999
        self.validar_numero_maximo(maximo, valor)

        return True