# -*- coding: utf-8 -*-

import unittest

from at.utiles import _
from at.utiles.scripts.ciudades import Ciudades
from at.orm.abm import ABM


class CiudadesTesting(Ciudades):

    def __init__(self):
        Ciudades.__init__(self)

        gis_test = {
            'user': 'postgres',
            'passwd': 'TrackAir',
            'dbname': 'gis-test',
            'name': 'gis-test',
            'host': '192.168.0.68',
            'engine': 'postgres',
            'port': '5432',
        }
        self.gis2 = ABM(gis_test)


class TestCiudades(unittest.TestCase):

    def setUp(self):
        self.ct = CiudadesTesting()

        self.ct.gis2.borrar('ciudades_aplicaciones')

    def tearDown(self):
        self.ct.gis2.borrar('ciudades_aplicaciones')

    def test_cargar_ciudades_aplicaciones(self):
        # NOTA: Comento este tests porque es tarda demasiado en ejecutarse
        pass
        # # Agrego a Rosario como la ciudad principal con id 1
        # dic = {}
        # dic['id'] = 1
        # dic['id_ciudad'] = 324
        # agregar = self.ct.gis2.agregar('ciudades_aplicaciones', **dic)
        # self.assertTrue(agregar is True)
        #
        # # Cargo las ciudades de la provincia de Santa Fe
        # id_provincia = 20
        # rta = self.ct.cargar_ciudades_aplicaciones(id_provincia)
        # self.assertTrue(rta['Estado'] is True)
        # self.assertTrue(
        #     rta['Respuesta'] ==
        #     _(u'Se agregaron todas las ciudades de la provincia 20')
        # )
        #
        # # Le paso una provincia que no existe
        # id_provincia = 987654
        # rta = self.ct.cargar_ciudades_aplicaciones(id_provincia)
        # self.assertTrue(rta['Estado'] is False)
        # self.assertTrue(
        #     rta['Respuesta'] ==
        #     _(u'No se encontraron ciudades de la provincia 987654')
        # )


def test_suite():
    from unittest import TestSuite
    from unittest import makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestCiudades))
    return suite
