# -*- coding: utf-8 -*-

import unittest

from at.utiles import _
from at.utiles.conexion import verificar_conexion_cp
from at.utiles.conexion import verificar_conexion_internet


class TestConexion(unittest.TestCase):

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def test_verificar_conexion_cp(self):
        r = verificar_conexion_cp()
        self.assertTrue(r is True)

    def test_verificar_conexion_internet(self):
        # Caso correcto
        rta = verificar_conexion_internet()
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(rta['Respuesta'] == _(u'Hay internet'))


def test_suite():
    from unittest import TestSuite
    from unittest import makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestConexion))
    return suite
