# -*- coding: utf-8 -*-

import unittest

from at.utiles.debug import obtener_memoria_consumida
from at.utiles.debug import log_memoria_consumida


class TestDebug(unittest.TestCase):

    def test_obtener_memoria_consumida(self):
        pid = 5603
        resultado = obtener_memoria_consumida(pid)
        try:
            self.assertTrue(isinstance(resultado, unicode))
        except:
            # NOTA: Para Python 3 no es unicode, es solo str
            self.assertTrue(isinstance(resultado, str))

    def test_log_memoria_consumida(self):
        pid = 5603
        resultado = log_memoria_consumida(pid)
        self.assertTrue(resultado is None)


def suite():
    from unittest import TestSuite
    from unittest import makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestDebug))
    return suite
