# -*- coding: utf-8 -*-

import unittest
import time

from at.utiles.procesos import ejecutar_proceso
from at.utiles.procesos import ejecutar_multiples_procesos
from at.utiles.procesos import ejecutar_tarea


class TestProcesos(unittest.TestCase):

    # NOTA: Comento estos test porque ejecuta varios hilos
    # con sleep y se demoran

    def mi_funcion(self, parametro_uno, parametro_dos):
        suma = parametro_uno + parametro_dos
        # Pongo un sleep para simular que esta tarea es muy pesada y se tarda
        # 5 segundos en terminar de ejecutar
        time.sleep(5)
        print('suma')
        print(suma)
        return suma

    def rta_mi_funcion(self, rta):
        print('*** Esta es la respuesta de la funcion')
        print(rta)

    def rta_mis_procesos(self, rta):
        print('***  Terminaron todos los procesos')
        print(rta)

    def rta_mis_procesos_sin_parametros(self):
        print('***  Terminaron todos los procesos sin parametros')

    def test_ejecutar_proceso(self):
        pass
        # # Probando una función en un subproceso
        # parametros = (2, 3)
        # daemon = False
        # rta = ejecutar_proceso(
        #     self.mi_funcion, parametros, daemon, self.rta_mi_funcion
        # )
        # self.assertTrue(rta is None)

    def test_ejecutar_multiples_procesos(self):
        pass
        # # Ejecuto 3 procesos al mismo tiempo sin función de respuesta
        # funciones = []
        # funciones.append([self.mi_funcion, (11, 12)])
        # funciones.append([self.mi_funcion, (13, 14)])
        # funciones.append([self.mi_funcion, (15, 16)])
        # daemon = False
        # max_procesos = 3
        # rta = ejecutar_multiples_procesos(
        #     funciones, daemon, max_procesos=max_procesos
        # )
        # self.assertTrue(rta is None)

    def test_con_valor_rta_ejecutar_multiples_procesos(self):
        pass
        # # Ejecuto cada 1 función con un valor de respuesta
        # funciones = []
        # funciones.append([self.mi_funcion, (1, 2)])
        # funciones.append([self.mi_funcion, (2, 3)])
        # daemon = False
        # func_fin_procesos = self.rta_mis_procesos
        # valor_rta = 'Esta es una respuesta fija para cuando termine todo'
        # max_procesos = 1
        # rta = ejecutar_multiples_procesos(
        #     funciones, daemon, func_fin_procesos, valor_rta, max_procesos
        # )
        # self.assertTrue(rta is None)

    def test_sin_valor_rta_ejecutar_multiples_procesos(self):
        pass
        # # Ejecuto sin valor de respuesta pero si le paso una función
        # # Le paso max_procesos en 0, me lo valida y lo cambia a 1
        # funciones = []
        # funciones.append([self.mi_funcion, (5, 6)])
        # funciones.append([self.mi_funcion, (7, 8)])
        # daemon = False
        # func_fin_procesos = self.rta_mis_procesos_sin_parametros
        # max_procesos = 0
        # rta = ejecutar_multiples_procesos(
        #     funciones, daemon, func_fin_procesos, max_procesos=max_procesos
        # )
        # self.assertTrue(rta is None)

    def test_ejecutar_10_multiples_procesos(self):
        pass
        # # Ejecuto 10 procesos cada 4 con función y valor fijo de respuesta
        # funciones = []
        # funciones.append([self.mi_funcion, (1, 2)])
        # funciones.append([self.mi_funcion, (2, 3)])
        # funciones.append([self.mi_funcion, (3, 4)])
        # funciones.append([self.mi_funcion, (4, 5)])
        # funciones.append([self.mi_funcion, (5, 6)])
        # funciones.append([self.mi_funcion, (6, 7)])
        # funciones.append([self.mi_funcion, (7, 8)])
        # funciones.append([self.mi_funcion, (8, 9)])
        # funciones.append([self.mi_funcion, (9, 10)])
        # funciones.append([self.mi_funcion, (10, 11)])
        # daemon = False
        # func_fin_procesos = self.rta_mis_procesos
        # valor_rta = 'Esta es una respuesta fija para cuando termine todo'
        # max_procesos = 4
        # rta = ejecutar_multiples_procesos(
        #     funciones, daemon, func_fin_procesos, valor_rta, max_procesos
        # )
        # self.assertTrue(rta is None)

    def test_max_procesos_negativo_ejecutar_multiples_procesos(self):
        pass
        # # Le paso max_procesos en negativo, me lo valida y lo cambia a 1
        # funciones = []
        # funciones.append([self.mi_funcion, (13, 14)])
        # daemon = False
        # max_procesos = -5
        # rta = ejecutar_multiples_procesos(
        #     funciones, daemon, max_procesos=max_procesos
        # )
        # self.assertTrue(rta is None)

    def test_max_procesos_mayor_ejecutar_multiples_procesos(self):
        pass
        # # Le paso max_procesos mayor al total de procesos
        # funciones = []
        # funciones.append([self.mi_funcion, (20, 21)])
        # daemon = False
        # max_procesos = 4
        # rta = ejecutar_multiples_procesos(
        #     funciones, daemon, max_procesos=max_procesos
        # )
        # self.assertTrue(rta is None)

    def test_procesos_ejecutar_tarea(self):
        pass
        # funcion = self.mi_funcion
        # parametros = (6, 3)
        # segundos = 3
        # rta = ejecutar_tarea(funcion, parametros, segundos)
        # self.assertTrue(rta is None)


def suite():
    from unittest import TestSuite
    from unittest import makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestProcesos))
    return suite
