# -*- coding: utf-8 -*-

import unittest
import datetime

from at.utiles import _
from at.utiles import shell


class TestEjecutarComandos(unittest.TestCase):

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def test_ejecutar_comando(self):
        # Le paso un comando.
        comando = 'pwd'
        c = shell.ejecutar_comando(comando)
        self.assertTrue(c['Estado'] is True)

        # Le paso un comando.
        comando = 'pwdasd'
        c = shell.ejecutar_comando(comando)
        self.assertTrue(c['Estado'] is False)

        # Le paso un comando.
        comando = 'ls'
        c = shell.ejecutar_comando(comando)
        self.assertTrue(c['Estado'] is True)

        # Le paso un comando.
        comando = 'ls -lah'
        c = shell.ejecutar_comando(comando)
        self.assertTrue(c['Estado'] is True)

        # Le paso un comando.
        comando = 'pwd -lah'
        c = shell.ejecutar_comando(comando)
        self.assertTrue(c['Estado'] is False)


def suite():
    from unittest import TestSuite
    from unittest import makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestEjecutarComandos))
    return suite
