# -*- coding: utf-8 -*-

from at.cpbot.sqla_repository_filtros_palabras import FiltrosRepository
from at.utiles.singleton_decorador import singleton


@singleton
class ControladorFiltros(object):
    def __init__(self):
        self.sqla_repository_filtros = FiltrosRepository()

    def filtros(self, datos):
        metodo = datos['metodo']
        rta = {False, 'no existe el metodo'}

        id_filtro_palabra = datos.get('id_filtro_palabra')
        palabra = datos.get('palabra')
        id_filtro_call = datos.get('id_filtro_call')

        print(metodo)
        if metodo.upper() == 'ACTUALIZAR': rta = self.sqla_repository_filtros.actualizar(id_filtro_palabra, palabra)

        elif metodo.upper() == 'AGREGAR': rta = self.sqla_repository_filtros.agregar(palabra, id_filtro_call)

        elif metodo.upper() == 'BORRAR': rta = self.sqla_repository_filtros.borrar(id_filtro_palabra)

        elif metodo.upper() == 'LISTAR': rta = self.sqla_repository_filtros.obtener(id_filtro_call)

        elif metodo.upper() == 'OBTENER': rta = self.sqla_repository_filtros.listar_filtros_call()

        return rta
