from at.cpbot.domain.parametros_globales import ParametrosGlobales
from at.cpbot.adapters.sqla_repository_parametros_globales import ParametrosGlobalesRepository
from at.utiles.conversiones import respuesta


def inicializar_parametros_globales():
    sqla_repository_parametros = ParametrosGlobalesRepository()
    token_arcgis = None


    rta = sqla_repository_parametros.listar()
    print("listar:", rta)
    if not rta['Estado']:
        return rta



    datos = rta['Dato']

    for dato in datos:
        if dato['id_api'] == 8:
            token_arcgis = dato['token']
            break
    if not token_arcgis:
        return "no hay token arcgis"



    parametros_globales = ParametrosGlobales()

    parametros_globales.setear_token_arcgis(token_arcgis)



    rta = sqla_repository_parametros.obtener_region_busqueda()
    if not rta['Estado']:
        return rta
    region_busqueda = rta['Dato'][0]
    parametros_globales.setear_region_busqueda(region_busqueda)



    return respuesta(True, 'se inicalizo bien los parametros')
