# -*- coding: utf-8 -*-
import unittest
from at.cpbot.adapters.sqla_repository_parametros_globales import ParametrosGlobalesRepository
import at.cpbot.service_layer.sesion as sesion


class TestParametros(unittest.TestCase):

    def setUp(self):
        self.parametros_globales_repository = ParametrosGlobalesRepository()

        # # en caso de querer usar una de prueba, sino comentado funciona porque se conecta
        # self.datos_atapis_test = {
        #     'user': 'postgres',
        #     'passwd': 'TrackAir',
        #     'dbname': 'atapis_test',
        #     'name': 'atapis_test',
        #     'host': '192.168.0.68',
        #     'engine': 'postgres',
        #     'port': '5432',
        # }
        # self.parametros_globales_repository.atapis_test = ABM(self.datos_atapis_test)

    def test_abm_filtros2(self):
        rta = self.parametros_globales_repository.listar()
        assert rta['Estado'] is True

    def test_obtener(self):
        rta = self.parametros_globales_repository.obtener(8, '4131313')
        assert rta['Estado'] is True

    def test_obtener_region_busqueda(self):
        rta = self.parametros_globales_repository.obtener_region_busqueda()
        assert rta['Estado'] is True

    def test_reloco(self):
        rta = sesion.inicializar_parametros_globales()
        print("salida:", rta)


# ejecutar este comando en la terminal para correr el test
# /home/matias/workspace/buildoutweb.cpbot/bin/mi_python /home/matias/workspace/buildoutweb.cpbot/src/at.cpbot/at/cpbot/tests/test_parametros_globales.py
if __name__ == '__main__':
    unittest.main()

# dejo de andar porque trata de usar el psycopg2.6.2. pero ahora la conexion a atapis solo anda con el 2.7
# tendria que arreglar el que ejecuta los test