# -*- coding: iso-8859-1 -*-

import unittest
import os

from at.map import _
from at.map.area_generator import crear_mapas_zip
from at.map.area_generator import crear_area


class TestAreaGenerator(unittest.TestCase):

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def test_crear_mapas_zip(self):
        if os.getegid() != 0:
            print '######PARA EJECUTAR test_crear_mapa_zip DEBE SER ROOT ######'
            return
        r = crear_mapas_zip(0,1)
        self.assertTrue(r['Estado'] is True)
        self.assertTrue(r['Respuesta'] ==
                            _(u'El archivo ZIP ha sido creado correctamente'))

    def test_crear_area(self):
        latitud0 = -32.9560017586
        longitud0 = -60.7492554188
        latitud1 = -32.954864502
        longitud1 = -60.7492339611
        z1 = 10
        z2 = 17
        forzar = True
        basico = False
        sub_directorio = 'mficcimdcrkuuyzmgnix'
        multiprocess = True
        func_rta = self.rta_multiprocesos
        rta = crear_area(latitud0, longitud0, latitud1, longitud1, z1, z2,
                         forzar, basico, sub_directorio, multiprocess, func_rta)

        print rta

    def rta_multiprocesos(self, rta):
        print 'entro a rta_multiprocesos'
        print rta


def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestAreaGenerator))
    return suite
