# -*- coding: iso-8859-1 -*-
from at.map.utiles.validaciones_especificas import ValidacionesEspecificas


class Punto(ValidacionesEspecificas):

    def __init__(self, x=None, y=None, id_mapa=None, latitud=None,
                 longitud=None):

        if id_mapa is not None:
            if not self.validar_id_mapa(id_mapa):
                return self.validar_id_mapa(id_mapa)

        if x is not None:
            if not self.validar_entero(x):
                return self.validar_entero(x)

            if not self.validar_no_vacio(x):
                return self.validar_entero(x)

        if y is not None:
            if not self.validar_entero(y):
                return self.validar_entero(y)

            if not self.validar_no_vacio(y):
                return self.validar_entero(y)

        if latitud is not None:
            if not self.validar_numero(latitud):
                return self.validar_numero(latitud)

            if not self.validar_no_vacio(latitud):
                return self.validar_entero(latitud)

        if longitud is not None:
            if not self.validar_numero(longitud):
                return self.validar_numero(longitud)

            if not self.validar_no_vacio(longitud):
                return self.validar_entero(longitud)

        self.id_mapa = id_mapa
        self.x = x
        self.y = y
        self.latitud = latitud
        self.longitud = longitud
