# -*- coding: utf-8 -*-

__author__ = 'leandro'

import gettext
from at.utiles.singleton import Singleton

singleton = Singleton()
singleton.parametros = {'domain': ''}
singleton.parametros = {'language': None}

def set_language(domain='AppName', languages=['es_AR'], local_dir='/var/lib/at/lang', force_change=False):

    if singleton.parametros.get('domain') is None or force_change:
        singleton.parametros['domain'] = domain

        lang = gettext.translation(domain=domain, localedir=local_dir,
                                    languages = languages,
                                    fallback = True,codeset= "utf-8")
        lang.install()
        singleton.parametros['language'] = lang

    return singleton.parametros['language']
