# -*- coding: utf-8 -*-

import os


def backup(db_names):
    ''' Realiza un dump de la DB '''
    if not isinstance(db_names, list):
        raise Exception, 'El argumento de mysql_dump debe ser una lista.'

    dest = os.path.join('/', 'var', 'lib', 'at', 'backups')

    def make_dump(db):
        ''' llama a mysqldump '''

        dbsql = db + '.sql'
        f_sql = os.path.join(dest, dbsql)

        cmd = 'mysqldump -CceKq --single-transaction --opt -u %s --password=%s %s > %s' % ('CP2000_User', 'User_CP2000', db, f_sql)

        # os.system(cmd)
        # print(cmd)

    for db in db_names:
        make_dump(db)

print(backup(['cp2000', 'gis']))
