import os
import boto
import boto.s3
import mimetypes
from boto.utils import compute_md5

# AWS ACCESS DETAILS
AWS_ACCESS_KEY_ID = 'AKIAIWIEGKJTKVCJOUAA'
AWS_SECRET_ACCESS_KEY = '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'

bucket_name = 'map.axsisweb'
dest_folder = 'map/1.0.0/basic'
conn = boto.connect_s3(AWS_ACCESS_KEY_ID, AWS_SECRET_ACCESS_KEY)
bucket = conn.get_bucket(bucket_name)

src_folder = '/var/lib/at/mapas'
z_folders = ['z7', 'z8', 'z9', 'z10','z11','z12','z13','z14','z15','z16','z17']
#z_folders = ['z17']


for z_folder in z_folders:
    namelist = []
    for root, dirs, files in os.walk(os.path.join(src_folder, z_folder)):
        if files and not '.svn' in root:
            path = os.path.relpath(root, src_folder)
            for f in files:
                name = os.path.normpath(os.path.join(path, f))
                print(name)
            #print([os.path.normpath(os.path.join(path, f)) for f in files])

    # print('Uploading %d files to bucket %s' % (len(namelist), bucket.name))
    #for name in namelist:

                # Obtengo el nombre del objeto.
                filename = os.path.join(
                    dest_folder, name.replace('.jpeg', '.jpg')
                )

                # Obtengo el objeto a actualizar
                content = open(os.path.join(src_folder, name))

                # Obtengo el tipo de archivo
                filetype, encoding = mimetypes.guess_type(name)
                filetype = filetype or 'application/octet-stream'

                # Seteo la cabecera.
                headers = {'Content-Type': filetype, 'x-amz-acl': 'public-read'}

                # Si existe el objeto, lo obtengo.
                if bucket.get_key(filename):
                    key = bucket.get_key(filename)
                    # print('- %s OBJETO ACTUALIZADO' % filename)
                    print('- %s OBJETO ACTUALIZADO' % key.name)

                # Sino, lo creamos.
                else:
                    key = bucket.new_key(filename)
                    states = [filetype]
                    states = ', '.join(states)
                    print('- %s = %s (%s) OBJETO NUEVO' % (name, key.name, states))

                # Guardo el contenido en el objeto.
                key.set_contents_from_file(content, headers, md5=compute_md5(content))
                key.make_public()
                content.close()
