# -*- coding: utf-8 -*-

import unittest

from at.utiles import _
from at.utiles.scripts.migrar_bd import MigrarBD
from at.utiles.scripts.migrar_bd import MigrarGold
from at.orm.utiles import obtener_bd


class TestMigrarBD(unittest.TestCase):

    def setUp(self):
        self.mt = MigrarBD()

    def tearDown(self):
        pass

    def test_procesar_archivo_csv(self):
        # NOTA: Comento este tests porque ya no tengo los archivos .CSV
        # en mi PC
        pass
        # # Caso correcto
        # ruta_archivo = '/home/paco/Descargas/Gold/bd/moviles.csv'
        # rta = self.mt.procesar_archivo_csv(ruta_archivo)
        # self.assertTrue(rta['Estado'] is True)
        # self.assertTrue(isinstance(rta['Respuesta'], list))
        # self.assertTrue(len(rta['Respuesta']) == 473)
        # self.assertTrue(len(rta['Respuesta'][0].keys()) == 70)
        #
        # # Le paso un archivo que no existe
        # ruta_archivo = '/home/paco/no_existe.csv'
        # rta = self.mt.procesar_archivo_csv(ruta_archivo)
        # self.assertTrue(rta['Estado'] is False)
        # self.assertTrue(
        #     rta['Respuesta'] ==
        #     _(u'No se encontró el archivo /home/paco/no_existe.csv')
        # )


class TestMigrarGold(unittest.TestCase):

    def setUp(self):
        # Instancio la clase MigrarGold
        self.gold = MigrarGold()

        # Obtengo la base de datos gold-cp2000
        nombre_bd = 'gold-cp2000'
        rta_obtener_bd = obtener_bd(nombre_bd)
        self.bd = rta_obtener_bd['Respuesta']

        # # Limpio las tablas
        # self.bd.borrar('filtros')
        # self.bd.borrar('aseguradoras')
        # self.bd.borrar('administradoras')
        # self.bd.borrar('titulares')
        # self.bd.borrar('choferes')
        # self.bd.borrar('moviles')
        # self.bd.borrar('equipos')
        # self.bd.borrar('filtros_moviles')
        # self.bd.borrar('tipos_abonos')
        # self.bd.borrar('centros_de_costos_personas')
        # self.bd.borrar('centros_de_costos')
        # self.bd.borrar('clientes_ctacte')

    def tearDown(self):
        pass

    ### COMENTO LOS TEST PARA MIGRAR GOLD #####################################
    # def test_gold_agregar_filtros(self):
    #     # Agrego los filtros que necesita GOLD
    #     nombre_bd = 'gold-cp2000'
    #     rta = self.gold.buscar_filtros_en_mensaje(nombre_bd)
    #     self.assertTrue(rta['Estado'] is True)
    #     self.assertTrue(
    #         rta['Respuesta'] == _(u'Se agregaron los filtros de forma correcta')
    #     )
    #
    #     # Le paso una base de datos que no existe
    #     nombre_bd = 'no_existe'
    #     rta = self.gold.buscar_filtros_en_mensaje(nombre_bd)
    #     self.assertTrue(rta['Estado'] is False)
    #     self.assertTrue(
    #         rta['Respuesta'] ==
    #         _(u'No se encontro la configuracion para conectarse a la base de datos no_existe')
    #     )
    #
    # def test_gold_agregar_aseguradoras(self):
    #     # Caso correcto
    #     nombre_bd = 'gold-cp2000'
    #     ruta_archivo = '/home/paco/Descargas/Gold/bd/aseguradoras.csv'
    #     rta = self.gold.agregar_aseguradoras(nombre_bd, ruta_archivo)
    #     self.assertTrue(rta['Estado'] is True)
    #     self.assertTrue(
    #         rta['Respuesta'] ==
    #         _(u'Se agregaron las aseguradoras de forma correcta')
    #     )
    #
    #     # Le paso una base de datos que no existe
    #     nombre_bd = 'no_existe'
    #     ruta_archivo = '/home/paco/Descargas/Gold/bd/aseguradoras.csv'
    #     rta = self.gold.agregar_aseguradoras(nombre_bd, ruta_archivo)
    #     self.assertTrue(rta['Estado'] is False)
    #     self.assertTrue(
    #         rta['Respuesta'] ==
    #         _(u'No se encontro la configuracion para conectarse a la base de datos no_existe')
    #     )
    #
    #     # Le paso un archivo que no existe
    #     nombre_bd = 'gold-cp2000'
    #     ruta_archivo = '/home/paco/no_existe.csv'
    #     rta = self.gold.agregar_aseguradoras(nombre_bd, ruta_archivo)
    #     self.assertTrue(rta['Estado'] is False)
    #     self.assertTrue(
    #         rta['Respuesta'] ==
    #         _(u'No se encontró el archivo /home/paco/no_existe.csv')
    #     )
    #
    # def test_gold_agregar_administradoras(self):
    #     # Caso correcto
    #     nombre_bd = 'gold-cp2000'
    #     ruta_archivo = '/home/paco/Descargas/Gold/bd/administradoras.csv'
    #     rta = self.gold.agregar_administradoras(nombre_bd, ruta_archivo)
    #     self.assertTrue(rta['Estado'] is True)
    #     self.assertTrue(
    #         rta['Respuesta'] ==
    #         _(u'Se agregaron las administradoras de forma correcta')
    #     )
    #
    # def test_gold_agregar_titulares(self):
    #     # Caso correcto
    #     nombre_bd = 'gold-cp2000'
    #     ruta_archivo = '/home/paco/Descargas/Gold/bd/titulares.csv'
    #     rta = self.gold.agregar_titulares(nombre_bd, ruta_archivo)
    #     self.assertTrue(rta['Estado'] is True)
    #     self.assertTrue(
    #         rta['Respuesta'] ==
    #         _(u'Se agregaron los titulares de forma correcta')
    #     )
    #
    # def test_gold_agregar_choferes(self):
    #     # Caso correcto
    #     nombre_bd = 'gold-cp2000'
    #     ruta_archivo = '/home/paco/Descargas/Gold/bd/choferes.csv'
    #     rta = self.gold.agregar_choferes(nombre_bd, ruta_archivo)
    #     self.assertTrue(rta['Estado'] is True)
    #     self.assertTrue(
    #         rta['Respuesta'] ==
    #         _(u'Se agregaron los choferes de forma correcta')
    #     )
    #
    # def test_gold_agregar_moviles(self):
    #     # Caso correcto
    #     nombre_bd = 'gold-cp2000'
    #     ruta_archivo = '/home/paco/Descargas/Gold/bd/moviles.csv'
    #     rta = self.gold.agregar_moviles(nombre_bd, ruta_archivo)
    #     self.assertTrue(rta['Estado'] is True)
    #     self.assertTrue(
    #         rta['Respuesta'] ==
    #         _(u'Se agregaron los móviles de forma correcta')
    #     )
    #
    # def test_gold_agregar_tipos_abonos(self):
    #     # Caso correcto
    #     nombre_bd = 'gold-cp2000'
    #     ruta_archivo = '/home/paco/Descargas/Gold/bd/abonos.csv'
    #     rta = self.gold.agregar_tipos_abonos(nombre_bd, ruta_archivo)
    #     self.assertTrue(rta['Estado'] is True)
    #     self.assertTrue(
    #         rta['Respuesta'] ==
    #         _(u'Se agregaron los tipos de abonos de forma correcta')
    #     )
    #
    # def test_gold_agregar_personas_centros_de_costos(self):
    #     # Caso correcto
    #     nombre_bd = 'gold-cp2000'
    #     ruta_archivo = '/home/paco/Descargas/Gold/bd/centros_de_costos_personas.csv'
    #     rta = self.gold.agregar_centros_de_costos_personas(
    #         nombre_bd, ruta_archivo
    #     )
    #     self.assertTrue(rta['Estado'] is True)
    #     self.assertTrue(
    #         rta['Respuesta'] ==
    #         _(u'Se agregaron las personas de los centros de costos de forma correcta')
    #     )
    #
    # def test_gold_agregar_centros_de_costos(self):
    #     # Caso correcto
    #     nombre_bd = 'gold-cp2000'
    #     ruta_archivo = '/home/paco/Descargas/Gold/bd/centros_de_costos.csv'
    #     rta = self.gold.agregar_centros_de_costos(
    #         nombre_bd, ruta_archivo
    #     )
    #     self.assertTrue(rta['Estado'] is True)
    #     self.assertTrue(
    #         rta['Respuesta'] ==
    #         _(u'Se agregaron los centros de costos de forma correcta')
    #     )
    #
    # def test_gold_agregar_clientes_ctacte(self):
    #     # Caso correcto
    #     nombre_bd = 'gold-cp2000'
    #     ruta_archivo = '/home/paco/Descargas/Gold/bd/clientes_ctacte.csv'
    #     rta = self.gold.agregar_clientes_ctacte(
    #         nombre_bd, ruta_archivo
    #     )
    #     self.assertTrue(rta['Estado'] is True)
    #     self.assertTrue(
    #         rta['Respuesta'] ==
    #         _(u'Se agregaron los clientes con cta. cte. de forma correcta')
    #     )
    #
    # def test_migrar_gold(self):
    #     # Prueba para migrar todos los datos de GOLD
    #     ruta_carpeta = '/home/paco/Descargas/Gold/bd'
    #     nombre_bd = 'gold-cp2000'
    #     rta = self.gold.migrar_gold(ruta_carpeta, nombre_bd)
    #     self.assertTrue(rta['Estado'] is True)
    #     self.assertTrue(
    #         rta['Respuesta'] ==
    #         _(u'Se terminó la migración de GOLD, revisar el LOG en /var/lib/at/logs/at.utiles/at.utiles.migracion_gold')
    #     )
    #
    # def test_agregar_centros_inexistentes(self):
    #     nombre_bd = 'gold-cp2000'
    #     rta = self.gold.agregar_centros_inexistentes(nombre_bd)
    #     print(rta)
    #
    # def test_modificar_centros_de_costos_inexistentes(self):
    #     nombre_bd = 'gold-cp2000'
    #     ruta_archivo = '/home/paco/Descargas/gold_01-03-2016/centros_de_costos_personas.csv'
    #     rta = self.gold.modificar_centros_de_costos_inexistentes(
    #         nombre_bd, ruta_archivo
    #     )
    #     print(rta)


def test_suite():
    from unittest import TestSuite
    from unittest import makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestMigrarBD))
    suite.addTest(makeSuite(TestMigrarGold))
    return suite
