# -*- coding: utf-8 -*-

import unittest
import os

from at.utiles.exportar import Exportar


class TestExportar(unittest.TestCase):

    def setUp(self):
        self.e = Exportar()

    def test_toXLS(self):
        ruta_archivo = os.path.join(os.path.expanduser('/tmp'), 'prueba.xls')
        titulo = 'Titulo de pueba'
        cabecera = ['Campo 1', 'Campo 2', 'Campo 3']
        data = [['dato 1-1', 'dato 1-2', 'dato 1-3'], ['dato 1-2', 'dato 2-2', 'dato 2-3']]
        tam_columna = [100, 100, 100]
        r = self.e.toXLS(ruta_archivo, titulo, cabecera, data, tam_columna)
        self.assertTrue(r == ruta_archivo)


def suite():
    from unittest import TestSuite
    from unittest import makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestExportar))
    return suite
