#!/home/matias/workspace/buildoutweb.cpbot/bin/mi_python
# -*- coding: utf-8 -*-

import unittest

from at.utiles import _
from at.utiles.filtros import Filtros
from at.orm.abm import ABM

cp = {'user': 'root',
      'passwd': 'changeme',
      'dbname': 'cp2000',
      'name': 'cp',
      'host': '192.168.0.51',
      'engine': 'mysql',
      'port': '3306',
      }


class FiltrosTesting(Filtros):

    def __init__(self):
        Filtros.__init__(self)
        self.cp = ABM(cp)


class TestFiltros(unittest.TestCase):

    def setUp(self):
        self.ft = FiltrosTesting()

    def test_listar(self):
        print("listando")
        rta = self.ft.listar()
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(len(rta['Respuesta']) == 13)


# /home/matias/workspace/buildoutweb.cpbot/bin/mi_python /home/matias/workspace/buildoutweb.cpbot/src/at.utiles/at/utiles/tests/test_filtros.py
if __name__ == '__main__':
    unittest.main()
